package model;

import java.io.Serializable;

/**
 * 
 * @author Angela Lucchi
 *  Classe che modella un prodotto in negozio
 */
public class ProdottoNegozio extends Prodotto implements Serializable {

    private static final long serialVersionUID = 1L;
    private int codice;
    private int disponibilita;

    public ProdottoNegozio(String tipo, String nome, float prezzo, int disponibilita) {
        super(tipo, nome, prezzo);
        this.disponibilita = disponibilita;
    }

    @Override
    public String toString() {
        return codice + " " + tipo + " " + nome + " " + prezzo + " " + disponibilita;
    }

    public int getCodice() {
        return codice;
    }

    public int getDisponibilita() {
        return disponibilita;
    }

    public void setDisponibilita(int i) {
        this.disponibilita = i;
    }

    public void setCodice(int code) {
        this.codice = code;
    }

}