package view;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import view.magazzino.GestioneMagazzino;
import view.negozio.GestioneNegozio;

/**
 * 
 * @author Angela Lucchi
 * Classe che fa partire l'applicazione
 */
public class MainFrame extends JFrame {
    private static final long serialVersionUID = 1L;
    private JPanel contentPane;
    private JButton sceltaMagazzino;
    private JButton sceltaNegozio;
    private JButton chiudiBtn;

    public static void main(String[] args) {
        MainFrame frame = new MainFrame();
        frame.setVisible(true);
    }

    /**
     * Creazione del frame
     */
    public MainFrame() {
        this.setTitle("MENU");
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setResizable(false);
        this.setBounds(450, 150, 225, 375);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        this.setContentPane(contentPane);
        contentPane.setLayout(null);

        sceltaMagazzino = new JButton("MAGAZZINO");
        sceltaMagazzino.setBounds(30, 15, 170, 100);
        contentPane.add(sceltaMagazzino);

        sceltaNegozio = new JButton("NEGOZIO");
        sceltaNegozio.setBounds(30, 125, 170, 100);
        contentPane.add(sceltaNegozio);

        chiudiBtn = new JButton("ESCI");
        chiudiBtn.setBounds(30, 235, 170, 100);
        contentPane.add(chiudiBtn);

        sceltaMagazzino.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent arg0) {
                new GestioneMagazzino().setVisible(true);
                chiudi();
            }

        });

        sceltaNegozio.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent arg0) {
                new GestioneNegozio().setVisible(true);
                chiudi();
            }

        });

        chiudiBtn.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent arg0) {
                chiudi();
            }

        });
    }

    /**
     * Chiusura del frame
     */
    private void chiudi() {
        setVisible(false);
        dispose();
    }
}
