package view.magazzino;

import java.awt.HeadlessException;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

import model.ProdottoMagazzino;
import control.GestoreMagazzino;
import exception.ExceptionEqualName;

/**
 * 
 * @author Angela Lucchi 
 * Classe che crea il frame per aggiungere un prodotto al
 *         magazzino
 */
public class AggiungiProdottoMag extends JFrame {

    private static final long serialVersionUID = 1L;
    private String tipoProdotto;
    private String nomeProdotto;
    private float prezzoProdotto;
    private int quantitaProdotto;

    private static final String TIPO = "";
    private static final String NOME = "";
    private static final String PREZZO = "";
    private static final String QUANTITA = "";

    private JPanel contentPane;
    private JLabel title;
    private JLabel nome;
    private JLabel tipo;
    private JLabel prezzo;
    private JLabel quantita;

    /**
     * Creazione del frame
     */
    public AggiungiProdottoMag() {
        this.setResizable(false);
        this.setTitle("AGGIUNGI PRODOTTO A MAGAZZINO");
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setBounds(100, 100, 500, 500);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        this.setContentPane(contentPane);
        contentPane.setLayout(null);

        title = new JLabel("AGGIUNGI A MAGAZZINO");
        title.setBounds(150, 30, 200, 54);
        contentPane.add(title);
        tipo = new JLabel("Tipo del prodotto");
        tipo.setBounds(30, 94, 200, 54);
        contentPane.add(tipo);
        nome = new JLabel("Nome del prodotto: ");
        nome.setBounds(30, 158, 200, 54);
        contentPane.add(nome);
        prezzo = new JLabel("Prezzo del prodotto: ");
        prezzo.setBounds(30, 222, 200, 54);
        contentPane.add(prezzo);
        quantita = new JLabel("Quantit inserita: ");
        quantita.setBounds(30, 286, 200, 54);
        contentPane.add(quantita);

        final JTextField jtfTipo = new JTextField(TIPO);
        jtfTipo.setBounds(250, 94, 200, 54);
        final JTextField jtfNome = new JTextField(NOME);
        jtfNome.setBounds(250, 158, 200, 54);
        nomeProdotto = jtfNome.getText();
        final JTextField jtfPrezzo = new JTextField(PREZZO);
        jtfPrezzo.setBounds(250, 222, 200, 54);
        final JTextField jtfQuantita = new JTextField(QUANTITA);
        jtfQuantita.setBounds(250, 286, 200, 54);

        contentPane.add(jtfTipo);
        contentPane.add(jtfNome);
        contentPane.add(jtfPrezzo);
        contentPane.add(jtfQuantita);

        JButton btnAggiungi = new JButton("AGGIUNGI");
        btnAggiungi.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                tipoProdotto = jtfTipo.getText().toLowerCase();
                nomeProdotto = jtfNome.getText().toLowerCase();
                // Controllo se l'utente ha inserito un numero come prezzo e
                // come quantit
                try {
                    prezzoProdotto = Float.parseFloat(jtfPrezzo.getText());
                } catch (Exception exc) {
                    JOptionPane.showMessageDialog(AggiungiProdottoMag.this, "Prezzo non valido!");
                    return;
                }
                try {
                    quantitaProdotto = Integer.parseInt(jtfQuantita.getText());
                } catch (Exception exc) {
                    JOptionPane.showMessageDialog(AggiungiProdottoMag.this, "Quantit non valida!");
                    return;
                }
                if (nomeProdotto.equals("") || tipoProdotto.equals("") || prezzoProdotto == 0.00
                        || quantitaProdotto == 0) {
                    JOptionPane.showMessageDialog(AggiungiProdottoMag.this,
                            "Prima di aggiungere un prodotto occorre inserire tutti i campi!");
                } else
                    try {
                        {
                            try {
                                GestoreMagazzino.daiIstanza().aggiungiProdM(new ProdottoMagazzino(tipoProdotto,
                                        nomeProdotto, prezzoProdotto, quantitaProdotto));
                            } catch (ExceptionEqualName ex) {
                                JOptionPane.showMessageDialog(AggiungiProdottoMag.this,
                                        "Il prodotto e' gia' presente nel sistema!");
                                return;
                            }
                            new GestioneMagazzino().setVisible(true);
                            chiudi();
                        }
                    } catch (HeadlessException ex2) {
                        ex2.printStackTrace();
                    }
            }
        });
        btnAggiungi.setBounds(30, 350, 200, 54);
        contentPane.add(btnAggiungi);

        JButton btnIndietro = new JButton("INDIETRO");
        btnIndietro.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                new GestioneMagazzino().setVisible(true);
                chiudi();
            }
        });
        btnIndietro.setBounds(250, 350, 200, 54);
        contentPane.add(btnIndietro);
    }

    /**
     * Chiusura del frame
     */
    public void chiudi() {
        setVisible(false);
        dispose();
    }
}
