package view.magazzino;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.border.EmptyBorder;

import view.negozio.GestioneNegozio;
import model.ProdottoNegozio;
import control.GestoreMagazzino;
import control.GestoreNegozio;
import exception.ExceptionNegativeNumber;
import exception.ExceptionNegativeQty;

/**
 * @author Angela Lucchi 
 * Frame per mandare una certa quantit di prodotto al
 *         negozio
 */
public class MandaFrame extends JFrame {

    int code;
    private JLabel title;
    int qty;

    private static final long serialVersionUID = 1L;

    public MandaFrame(final int codice) {
        this.code = codice;

        this.setResizable(false);
        this.setTitle("INVIO DI PRODOTTI");
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setBounds(100, 100, 500, 400);
        JPanel contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        this.setContentPane(contentPane);
        contentPane.setLayout(null);

        title = new JLabel("SELEZIONA QUANTITA DA INVIARE AL NEGOZIO");
        title.setBounds(150, 30, 300, 54);
        contentPane.add(title);

        final JSpinner spinner = new JSpinner();
        spinner.setValue(new Integer(1));
        spinner.setBounds(150, 100, 200, 54);
        contentPane.add(spinner);

        JButton btnOk = new JButton("OK");
        try {
            btnOk.addMouseListener(new MouseAdapter() {
                @Override
                public void mouseClicked(MouseEvent e) {
                    try {
                        qty = (int) spinner.getValue();
                        String nome = GestoreMagazzino.daiIstanza().get(codice).getNome();
                        String tipo = GestoreMagazzino.daiIstanza().get(codice).getTipo();
                        float prezzo = GestoreMagazzino.daiIstanza().get(codice).getPrezzo();

                        GestoreMagazzino.daiIstanza().mandaProd(codice, qty); // tolgo
                                                                               // la
                                                                               // qta
                                                                               // dal
                                                                               // magazzino

                        ProdottoNegozio pro = new ProdottoNegozio(tipo, nome, prezzo, qty);
                        if (GestoreNegozio.daiIstanza().contieneNome(nome)) { // se
                                                                              // nel
                                                                              // negozio
                                                                              // c'e'
                                                                              // gia'
                                                                              // l'articolo
                            int chiave = GestoreNegozio.daiIstanza().getChiave(nome);
                            GestoreNegozio.daiIstanza().modificaProd(chiave, pro);
                        } else { // se nel negozio non c'e' l'articolo
                            GestoreNegozio.daiIstanza().aggiungiProdN(pro);
                        }
                    } catch (ExceptionNegativeNumber exc) {
                        JOptionPane.showMessageDialog(MandaFrame.this,
                                "Per mandare un prodotto al negozio devi inserire un numero positivo!");
                        return;
                    } catch (ExceptionNegativeQty exc2) {
                        JOptionPane.showMessageDialog(MandaFrame.this,
                                "Non puoi inviare al negozio piu' merce di quella che possiedi!");
                        return;

                    }
                    chiudi();
                    new GestioneNegozio().setVisible(true);
                }
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
        btnOk.setBounds(150, 200, 200, 54);
        contentPane.add(btnOk);
    }

    public void chiudi() {
        setVisible(false);
        dispose();
    }
}
