package view.magazzino;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.border.EmptyBorder;

import control.GestoreMagazzino;
import exception.ExceptionNegativeNumber;

/**
 * @author Angela Lucchi 
 * Frame per ordinare un prodotto nel magazzino
 */
public class OrdinaFrame extends JFrame {

    private static final long serialVersionUID = 1L;
    int code;
    private JLabel title;
    int qty;

    public OrdinaFrame(final int codice) {
        this.code = codice;

        this.setResizable(false);
        this.setTitle("ORDINE");
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setBounds(100, 100, 500, 400);
        JPanel contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        this.setContentPane(contentPane);
        contentPane.setLayout(null);

        title = new JLabel("SELEZIONA QUANTITA DA ORDINARE");
        title.setBounds(150, 30, 300, 54);
        contentPane.add(title);

        final JSpinner spinner = new JSpinner();
        spinner.setValue(new Integer(1));
        spinner.setBounds(150, 100, 200, 54);
        contentPane.add(spinner);

        JButton btnAggiungi = new JButton("OK");
        try {
            btnAggiungi.addMouseListener(new MouseAdapter() {
                @Override
                public void mouseClicked(MouseEvent e) {
                    try {
                        qty = (int) spinner.getValue();
                        GestoreMagazzino.daiIstanza().ordinaProd(codice, qty);
                    } catch (ExceptionNegativeNumber exc) {
                        JOptionPane.showMessageDialog(OrdinaFrame.this,
                                "Per ordinare un prodotto devi inserire un numero positivo!");
                        return;
                    }

                    chiudi();
                    new GestioneMagazzino().setVisible(true);
                }
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
        btnAggiungi.setBounds(150, 200, 200, 54);
        contentPane.add(btnAggiungi);

    }

    public void chiudi() {
        setVisible(false);
        dispose();
    }
}
