package view.negozio;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.border.EmptyBorder;
import control.GestoreNegozio;
import exception.ExceptionNegativeNumber;
import exception.ExceptionNegativeQty;

/**
 * @author Angela Lucchi 
 * Frame per vendere un prodotto in negozio
 */
public class VendiFrame extends JFrame {

    private static final long serialVersionUID = 1L;
    int code;
    private JLabel title;
    int qty;

    public VendiFrame(final int codice) {
        this.code = codice;

        this.setResizable(false);
        this.setTitle("VENDI");
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setBounds(100, 100, 500, 400);
        JPanel contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        this.setContentPane(contentPane);
        contentPane.setLayout(null);

        title = new JLabel("SELEZIONA QUANTITA DA VENDERE");
        title.setBounds(150, 30, 300, 54);
        contentPane.add(title);

        final JSpinner spinner = new JSpinner();
        spinner.setValue(new Integer(1));
        spinner.setBounds(150, 100, 200, 54);
        contentPane.add(spinner);

        JButton btnAggiungi = new JButton("OK");
        try {
            btnAggiungi.addMouseListener(new MouseAdapter() {
                @Override
                public void mouseClicked(MouseEvent e) {
                    try {
                        qty = (int) spinner.getValue();
                        GestoreNegozio.daiIstanza().vendiProd(codice, qty);
                    } catch (ExceptionNegativeNumber exc) {
                        JOptionPane.showMessageDialog(VendiFrame.this,
                                "Per vendere un prodotto devi inserire un numero positivo!");
                        return;
                    } catch (ExceptionNegativeQty exc) {
                        JOptionPane.showMessageDialog(VendiFrame.this,
                                "Non puoi vendere una quantita' maggiore di quella che possiedi!");
                        return;
                    }

                    chiudi();
                    new GestioneNegozio().setVisible(true);
                }
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
        btnAggiungi.setBounds(150, 200, 200, 54);
        contentPane.add(btnAggiungi);

    }

    public void chiudi() {
        setVisible(false);
        dispose();
    }
}
